<?php
/**
 * @version		$Id: category.php 478 2010-06-16 16:11:42Z joomlaworks $
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.gr
 * @copyright	Copyright (c) 2006 - 2010 JoomlaWorks, a business unit of Nuevvo Webware Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class K2ModelCategory extends JModel
{

	function getData() {

		$cid = JRequest::getVar('cid');
		$row = & JTable::getInstance('K2Category', 'Table');
		$row->load($cid);
		return $row;
	}

	function save() {

		$mainframe = &JFactory::getApplication();
		jimport('joomla.filesystem.file');
		require_once (JPATH_COMPONENT.DS.'lib'.DS.'class.upload.php');
		$row = & JTable::getInstance('K2Category', 'Table');
		$params = & JComponentHelper::getParams('com_k2');
		if (!$row->bind(JRequest::get('post'))) {
			$mainframe->redirect('index.php?option=com_k2&view=categories', $row->getError(), 'error');
		}
		$row->description = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);

		if (!$row->id) {
			$row->ordering = $row->getNextOrder('parent = '.$row->parent.' AND trash=0');
		}

		if (!$row->check()) {
			$mainframe->redirect('index.php?option=com_k2&view=category&cid='.$row->id, $row->getError(), 'error');
		}

		if (!$row->store()) {
			$mainframe->redirect('index.php?option=com_k2&view=categories', $row->getError(), 'error');
		}

		if(!$params->get('disableCompactOrdering'))
			$row->reorder('parent = '.$row->parent.' AND trash=0');

		$file = JRequest::get('files');

		$savepath = JPATH_ROOT.DS.'media'.DS.'k2'.DS.'categories'.DS;

		if ($file['image']['error'] == 0 && !JRequest::getBool('del_image')) {
			$handle = new Upload($file['image']);
			if ($handle->uploaded) {
				$handle->file_auto_rename = false;
				$handle->file_overwrite = true;
				$handle->file_new_name_body = $row->id;
				$handle->image_resize = true;
				$handle->image_ratio_y = true;
				$handle->image_x = $params->get('catImageWidth', '100');
				$handle->Process($savepath);
				$handle->Clean();
			}
			else {
				$mainframe->redirect('index.php?option=com_k2&view=categories', $handle->error, 'error');
			}
			$row->image = $handle->file_dst_name;
		}


		if (JRequest::getBool('del_image')) {
			$currentRow = & JTable::getInstance('K2Category', 'Table');
			$currentRow->load($row->id);
			if (JFile::exists(JPATH_ROOT.DS.'media'.DS.'k2'.DS.'categories'.DS.$currentRow->image)) {
				JFile::delete(JPATH_ROOT.DS.'media'.DS.'k2'.DS.'categories'.DS.$currentRow->image);
			}
			$row->image = '';
		}
		//Goon Tags
        if($user->gid<24 && $params->get('lockTags'))
			$params->set('taggingSystem',0);
        $db = &JFactory::getDBO();
        $query = "DELETE FROM #__k2_tags_xref WHERE catID={intval($row->id)}";
        $db->setQuery($query);
        $db->query();

        if($params->get('taggingSystem')){

        	if($user->gid<24 && $params->get('lockTags'))
				JError::raiseError(403, JText::_("ALERTNOTAUTH"));

        	$tags = JRequest::getVar('tags', NULL, 'POST', 'array');
			if (count($tags)) {
				$tags = array_unique($tags);
				foreach ($tags as $tag) {
					$tag = str_replace('-','',$tag);
	                $query = "SELECT id FROM #__k2_tags WHERE name=".$db->Quote($tag) or die(mysql_error());
	                $db->setQuery($query);
	                $tagID = $db->loadResult();
	                if($tagID){
		                $query = "INSERT INTO #__k2_tags_xref (`id`, `tagID`, `catID`) VALUES (NULL, {intval($tagID)}, {intval($row->id)})";
		                $db->setQuery($query);
		                $db->query();
	                }
	                else {
	                	$K2Tag = &JTable::getInstance('K2Tag', 'Table');
	                	$K2Tag->name = $tag;
	                	$K2Tag->published = 1;
	                	$K2Tag->check();
	                	$K2Tag->store();
		                $query = "INSERT INTO #__k2_tags_xref (`id`, `tagID`, `catID`) VALUES (NULL, {intval($K2Tag->id)}, {intval($row->id)})";
		                $db->setQuery($query);
		                $db->query();
	                }
            	}
 			}

        }
        else {
        	$tags = JRequest::getVar('selectedTags', NULL, 'POST', 'array');
			if (count($tags)) {
				foreach ($tags as $tagID) {
	                $query = "INSERT INTO #__k2_tags_xref (`id`, `tagID`, `catID`) VALUES (NULL, {intval($tagID)}, {intval($row->id)})";
	                $db->setQuery($query);
	                $db->query();
            	}
 			}

  		}
//Goon end

		if (!$row->store()) {
			$mainframe->redirect('index.php?option=com_k2&view=categories', $row->getError(), 'error');
		}

		$cache = & JFactory::getCache('com_k2');
		$cache->clean();

		switch(JRequest::getCmd('task')) {
			case 'apply':
			$msg = JText::_('Changes to Category saved');
			$link = 'index.php?option=com_k2&view=category&cid='.$row->id;
			break;
			case 'saveAndNew':
			$msg = JText::_('Category saved');
			$link = 'index.php?option=com_k2&view=category';
			break;
			case 'save':
			default:
			$msg = JText::_('Category Saved');
			$link = 'index.php?option=com_k2&view=categories';
			break;
		}
		$mainframe->redirect($link, $msg);
		
	}

	function countCategoryItems($catid) {

		$db = & JFactory::getDBO();
		$catid = (int)$catid;
		$query = "SELECT COUNT(*) FROM #__k2_items WHERE catid={$catid} AND trash=0 ";
		$db->setQuery($query);
		$result = $db->loadResult();
		return $result;

	}
	
	//Goon Tags
	
    function getAvailableTags($catid = NULL) {

        $db = &JFactory::getDBO();
        $query = "SELECT * FROM #__k2_tags as tags";
        if (!is_null($catid))
            $query .= " WHERE tags.id NOT IN (SELECT tagID FROM #__k2_tags_xref WHERE catID=".(int)$catid.")";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        return $rows;
    }

    function getCurrentTags($catid) {

        $db = &JFactory::getDBO();
        $catid = (int) $catid;
        $query = "SELECT * FROM #__k2_tags as tags WHERE tags.id IN (SELECT tagID FROM #__k2_tags_xref WHERE catID={$catid})";
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        return $rows;
    }
	//Goon End

}
